import { NgModule } from '@angular/core';
import { Routes } from '@angular/router';

export const routes: Routes = [
  {
    path: '',
    loadChildren: () => import('./tabs/tabs.routes').then((m) => m.routes),
  },
  // 聊天模块
  {
    path: "chat/session/role/:roleId",
    loadComponent: () => import('./test-chat-panel/test-chat-panel.component').then(m => m.TestChatPanelComponent),
    runGuardsAndResolvers: "always",
  },
  {
    path: "chat/session/chat/:chatId",
    loadComponent: () => import('./test-chat-panel/test-chat-panel.component').then(m => m.TestChatPanelComponent),
    runGuardsAndResolvers: "always",
  },
  {
    path: 'chat/pro/chat/:chatId',
    redirectTo: '/chat/session/chat/:chatId',
    pathMatch: 'full'
  },
  {
    path: 'drug-category',
    loadComponent: () => import('./drug-category/drug-category.page').then( m => m.DrugCategoryPage)
  },
  {
    path: 'comp-uploader-hwobs',
    loadComponent: () => import('../app/comp-uploader-hwobs/comp-uploader-hwobs.component').then( m => m.CompUploaderHwobsComponent)
  }
];
