import { Component, OnInit } from '@angular/core';
import { IonicModule } from '@ionic/angular';
import { CommonModule } from '@angular/common';
import { Router } from '@angular/router';
import { TimeComponent } from 'src/app/component/time/time.component';
import { WeatherComponent } from 'src/app/component/weather/weather.component';

@Component({
  selector: 'feedback-help',
  templateUrl: './feedback-help.component.html',
  styleUrls: ['./feedback-help.component.scss'],
  imports:[
    IonicModule,
    CommonModule,
    TimeComponent,
    WeatherComponent,
  ],
  standalone: true,
})
export class FeedbackHelpComponent  implements OnInit {

  constructor(
    private router: Router
  ) { }

  ngOnInit() {}

  isModalOpen = false;
  selectedQuestion: any = null;


  //问题及解决
  questions = [
    { title: '如何修改密码？', 
      detail: '您可以通过点击我的主页“修改密码”链接来重置您的密码。' },
    { title: '如何联系客服？', 
      detail: '您可以通过应用内的“联系客服”功能与我们的ai客服团队联系。' },
    { title: '如何更新个人信息？', 
      detail: '点击我的信息或者头像，您可以编辑和更新您的个人信息。' },
    { title: '如何查看进行问诊？', 
      detail: '您可以通过首页ai医生进去选择与您病症相关科室的医生点击进行问诊' },
    { title: '如果我对 AI 的诊断结果有疑问怎么办？', 
      detail: '用户可以将自己的疑问和 AI 诊断结果反馈给客服人员，客服人员会初步判断情况' },
    { title: '我的问诊信息会被泄露吗？', 
      detail: '确保用户信息仅用于医疗诊断目的，我方承诺不会将其泄露给第三方机构或个人。' },
    { title: '我不知道如何准确描述自己的症状，怎么办？', 
      detail: '您只需跟ai医生描述您不舒服的地方，医生会对此进行深入提问，您问答医生提出的问题就行了。' },
    { title: '如何使用生成的个性化头像？', 
      detail: '您可以复制头像生成后最下方生成的图片地址到编辑信息弹窗进行头像应用。' },
    { title: '问题1', 
      detail: '解决方案' },
    { title: '问题2', 
      detail: '解决方案' },
    { title: '问题3', 
      detail: '解决方案' },
    { title: '问题4', 
      detail: '解决方案' },
    { title: '问题5', 
      detail: '解决方案' },
  ];

  //打开解决方案
  openDetail(question: any) {
    this.selectedQuestion = question;
    this.isModalOpen = true;
  }

  //返回我的主页
  backHome(){
    this.router.navigate(['/tabs/tab4'])
  }
}