import { CommonModule } from '@angular/common';
import { Component, OnInit } from '@angular/core';
import { Router } from '@angular/router';
import { IonButton, IonCard, IonCardContent, IonCardHeader, IonCardSubtitle, IonCardTitle, IonContent, IonHeader, IonTitle, IonToolbar, NavController } from '@ionic/angular/standalone';

@Component({
  selector: 'app-guide',
  templateUrl: './guide.component.html',
  styleUrls: ['./guide.component.scss'],
  standalone: true,
  imports:[
    IonContent,
    IonCard,
    IonTitle,
    IonToolbar,
    IonHeader,
    IonCardContent,
    IonCardTitle,
    IonCardHeader,
    IonButton,
    IonCardSubtitle,
    CommonModule
  ]
})
export class GuideComponent  implements OnInit {

  constructor(
    private router: Router,
    private navCtrl: NavController
  ) { }

  ngOnInit() {}

  features = [
    {
      title: '信息填写',
      description: '登入系统后，填写您的信息方能给您更完美的问诊服务',
      path:'tabs/tab4'
    },
    {
      title: 'AI问诊',
      description: '不同科室的ai医生能解决您日常生活绝大多数的不适病症，或者给您提供准确的建议',
      path:'tabs/inquiry/ai'
    },
    {
      title: '药品展示',
      description: '我们会向您展示日常生活中常用的非处方药品，展示其的作用、价格和成分信息等，方便您去药店购买',
      path:'tabs/tab3'
    },
    {
      title: '创建AI',
      description: '您可以通过需求描述创建一个更符合您意愿的ai医生，他的回复建议将更贴合您的需求，作为您的专属医生',
      path:'tabs/create-agent'
    },
    {
      title: '我的健康',
      description: '借此您能浏览您所有的问诊记录，来回顾您的健康历程',
      path:'tabs/my-health'
    },
    {
      title: '健康热点',
      description: '它为您找寻到了网上最受关注的健康知识并将其分类，以方便您的查看',
      path:'tabs/tab2'
    },
    // 可以继续添加更多功能
  ];

  goToPage(feature:any){
    this.router.navigate([feature.path])
  }

  backHome(){
    this.router.navigate(['tabs/tab4'])
  }
}
