# 智养人生（健康社区）项目策划书
- 小组 好业余小组
- 学号 202226701018
- 班级 22级软件工程
- 手机 15669987185

# 项目设想
- 一句话描述项目设想（行业领域、用户画像、核心功能）
- 在健康行业领域，为注重养生的中老年人打造一款健康服务app，提供健康知识科普、在线问诊、健康监测提醒等核心功能。

AGI可结合的功能方向
- 个性化健康方案定制
    - 智能健康评估
    - 动态养生计划生成
- 健康知识科普的深化与优化
    - 智能知识推送
    - 知识问答增强
- 在线问诊的拓展
    - 智能问诊助手
    - 医生资源整合
    - 智能病历生成与辅助
- 健康监测提醒的优化
    - 智能监测提醒
    - 健康数据管理
    - 生活方式调整提醒
- 社交与心理关怀功能
    - 健康社区智能引导
    - 心理状态监测与干预

# 项目背景
## 政策背景
- 近日，国家卫生健康委等15部门联合印发《“十四五”健康老龄化规划》。《规划》提出，到2025年，老年健康服务资源配置更加合理，综合连续、覆盖城乡的老年健康服务体系基本建立，老年健康保障制度更加健全，老年人健康生活的社会环境更加友善，老年人健康需求得到更好满足，老年人健康水平不断提升，健康预期寿命不断延长。
- 《“健康中国2030”规划纲要》提出，要为老年人提供治疗期住院、康复期护理、稳定期生活照料、安宁疗护一体化的健康和养老服务。
- 为深入贯彻习近平总书记关于老龄工作的重要指示精神，贯彻落实全国老龄工作会议精神和《中共中央 国务院关于加强新时代老龄工作的意见》《中共中央 国务院关于促进中医药传承创新发展的意见》《“十四五”中医药发展规划》有关要求，在健康老龄化工作中进一步发挥中医药作用，现就加强中医药老年健康服务工作制定本实施方案。

## 行业背景
- 据中研普华产业院的研究《2024-2029年中国健康养生行业市场分析及发展前景预测报告》，2023年中国大健康市场规模已达到77127亿元，并预测2024年将达到9万亿元，至2030年有望突破16万亿元大关。这一增长趋势反映了人们对健康养生的日益重视以及生活水平的提高和消费结构的变化。
- 健康行业市场规模逐年增长，中老年人注重养生的需求日益增加。
- 健康行业竞争激烈，但市场上缺乏一款真正满足中老年人需求的健康服务平台。

## 市场痛点
- 痛点1 健康知识普及不足，中老年人难以获取准确、实用的健康信息。
- 痛点2 在线问诊渠道有限，中老年人难以找到专业医生进行咨询。
- 痛点3 健康监测提醒不够智能化，中老年人难以及时了解自己的健康状况。
- 痛点4 社交与心理关怀功能缺失，中老年人难以找到志同道合的朋友和专业人士进行交流。

# 产品定位
## 用户分析
- 用户群体：中老年人

## 主要功能
- 健康知识科普：提供健康养生知识、疾病预防、饮食建议等。
- 在线问诊：用户可以在线咨询医生，获取专业健康建议。
- 智能病历生成与辅助：根据用户填写的信息，自动生成病历，并提供辅助诊断功能。
- 健康监测提醒：智能监测用户健康状况，提醒用户进行健康检查和调整。
- 社交与心理关怀：提供健康社区，用户可以与其他用户交流，分享健康心得，获取心理支持。
- 个性化健康方案：根据用户健康状况和需求，提供个性化的健康方案。

## 商业模式
- 广告收入：通过在应用内展示少量广告，获取广告收入。
- 会员服务：提供会员服务，提供更多高级功能和服务。
- 健康服务：与医疗机构、医院合作，提供健康咨询服务。
- 健康产品：销售与健康相关的产品，如保健品、医疗器械等。

# 可行性测试
## 健康知识科普
- 健康养生知识
    - 适度运动：中老年人适合进行一些舒缓的运动，如太极拳、八段锦、散步等。
    - 规律作息：保持规律的作息时间有助于调整生物钟，促进身体的新陈代谢。
    - 心理健康维护：保持积极乐观的心态对健康至关重要。
- 疾病预防
    - 心血管疾病预防
        - 定期测量血压：定期测量血压、血脂和血糖，了解自己的身体指标。
        - 戒烟限酒：减少心血管疾病的危险因素。
    - 糖尿病预防
        - 注意饮食结构：控制碳水化合物的摄入量，增加膳食纤维的摄入。
        - 保持适量运动：提高身体对胰岛素的敏感性。
        - 定期进行体检：关注空腹血糖和餐后血糖的变化。
    - 癌症预防
        - 保持健康生活方式：如不吸烟、不饮酒、规律作息、均衡饮食等。
        - 定期进行防癌筛查：如肺癌筛查（低剂量螺旋 CT 对于高危人群）、乳腺癌筛查（乳腺钼靶和超声检查）、结直肠癌筛查（结肠镜检查）等。
- 饮食建议
    - 食物多样化：保证摄入各类营养素
    - 控制油盐糖摄入：减少食用油的使用量，选择植物油，如橄榄油、亚麻籽油等富含不饱和脂肪酸的油类。
    - 增强膳食纤维：膳食纤维有助于促进肠道蠕动、预防便秘和降低胆固醇。

## 在线问诊
- 智能问诊小助手
    - 根据用户提供的信息，提供辅助诊断功能
> 根据提示词：你是一名优秀的全科医生，请您根据用户提供的信息，提供专业的健康建议。
```
聊天记录
用户：我最近感觉胸口有点痛，是不是心脏有问题？
医生：···
```

- 智能病历生成与辅助
    - 提供病历模板，用户填写信息后，自动生成病历
> 根据提示词：你是一名优秀的全科医生，请根据用户提供一份病历模板表格。
```
病例表模板 如：
患者基本信息
姓名：____________________
性别：____________________
年龄：____________________
身高：____________________
体重：____________________
联系电话：________________
地址：____________________

就诊信息
就诊日期：________________
主诉：__________________________________________________
现病史：________________________________________________
既往史：________________________________________________
家族史：________________________________________________
过敏史：________________________________________________

体格检查
体温：______ °C
脉搏：______ 次/min
呼吸：______ 次/min
血压：______ mmHg
身体状况：_____________________________________________

辅助检查
实验室检查：
血常规：____________________
生化检查：__________________
尿常规：____________________
影像学检查：
X光/CT/MRI：_______________
其他检查：_________________

诊断
初步诊断：_____________________________________________
可能的鉴别诊断：______________________________________

治疗计划
药物治疗：_____________________________________________
非药物治疗：___________________________________________
随访计划：_____________________________________________

医师签名： ____________________
日期： ________________________
```


- 医生资源整合
    - 与专业医生合作，提供在线问诊服务
    - 医生认证机制，确保服务质量
    - 医生在线时间表，方便用户预约

- 社交与心理关怀
    - 健康社区：用户可以与其他用户交流，分享健康心得，获取心理支持
    ```
    用户1：健康绝非仅仅是身体无病痛，心理的平衡与和谐同样关键。中老年人历经岁月洗礼，面对生活的诸多变化，极易产生情绪波动。

    用户2：确实如此，保持心理健康对中老年人来说尤为重要。我们可以通过一些简单的心理调适方法来维持内心的平衡，比如冥想、深呼吸等。
    ```
    - 健康活动：组织健康活动，如瑜伽、舞蹈、歌唱等，促进中老年人之间的交流
    ```
    1、活动概述
        目的：通过举办丰富多样的健康活动，如瑜伽、舞蹈、歌唱等，增强中老年人的身体素质，丰富他们的精神文化生活，促进社区中老年人之间的交流与互动，营造和谐、积极向上的社区氛围，助力他们安享健康快乐的晚年时光。
        对象：本社区 50 岁及以上的中老年人。
        时间与地点：[具体活动时间]，社区活动中心 [或户外广场，根据实际情况确定]。
    
    2、前期准备
        需求调研
        场地布置
        宣传推广
        物资准备
        人员安排
   
    3、活动流程
        活动环节	时间安排	具体内容
        ···         ···         ···
   
    4、后续跟进
        反馈收集与整理
        建立健康活动社群
        定期组织后续活动
   
    5、注意事项
        安全保障
        舒适环境营造
        尊重个体差异
    ```

- 个性化健康方案
    - 根据用户健康状况和需求，提供个性化的健康方案
    ```
    1、用户基本信息收集
        年龄
        性别
        身高
        体重
        健康状况
        健康需求

    2、健康评估
        健康风险评估
        健康状况评估

    3、个性化健康方案制定
        健康目标设定
        健康计划制定
        健康干预措施
    ```

# 产品结构
## 竞品分析
- 竞品1：健康中国
- 竞品2：春雨医生

## 产品结构图
![智养人生的产品结构图](./img/1.jpg)

## 信息结构图
![智养人生的产品结构图](./img/2.jpg)

# 项目名称：智养人生
